import base64
import requests
import pandas as pd
import xmindparser
from copy import deepcopy

xmindparser.config = {
            'showTopicId': True, # 是否展示主题ID
            'hideEmptyValue': True # 是否隐藏空值
        }

def relational_case(project):
    jiraAddress,user,password="http://jira.galaxy-immi.com","wallen.ywh","ywh940509"
    headers={
        "Authorization":"Basic "+base64.b64encode((user+":"+password).encode('utf-8')).decode(),
        "accept":"application/json,text/javascript,*/*;q=0.01"
    }
    id_=requests.request("get",jiraAddress+"/rest/agile/1.0/board?projectKeyOrId="+project,headers=headers).json().get("values")[0].get("id")
    result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(id_)+"&selectedProjectKey="+project,headers=headers).json()
    all=result.get("issues")
    type_={}
    for k,v in result["entityData"]["types"].items():
        type_[str(k)]=v["typeName"]
    storyids={}
    [storyids.update({i.get("key"):[]}) for i in list(filter(lambda x:type_[x["typeId"]]=="Story",all))]
    for item in list(filter(lambda x:type_[x["typeId"]]=="测试用例",all)):
        for each in storyids.keys():
            each in item.get("summary") and storyids[each].append(item.get("key"))
    for k,v in storyids.items():
        print(k,v)
        res=requests.request("post",jiraAddress+"/rest/synapse/latest/requirementTestCase/addTestCase",headers=headers,json={"currentReqkey":k,"testCaseKeys":v,"history":"yes"})
        print(res.status_code)
        print(res.url)
        print(res.headers)
        # print(res.)
        

def makecase(filePath):
    content = xmindparser.xmind_to_dict(filePath)
    case_list=[]
    # print(content)
    def a(info,new,type):
        for each in info:
            oldinfo=deepcopy(new)
            newtype=type
            if not ((each["title"])=="Map" or (each["title"])=="测试用例" or (each["title"])=="sheet"):
                if type=="name":
                    string=each.get("title")
                    if "tc：" in each.get("title") or "tc：" in each.get("title") or "tc:" in each.get("title"):
                        string=each.get("title").replace("tc：","").replace("tc：","").replace("tc:","")
                        newtype="step"
                    if oldinfo.get("name"):
                        oldinfo["name"]=oldinfo.get("name") and oldinfo.get("name")+"->"+string or string
                    else:
                        oldinfo["name"]=string
                elif type=="step":
                    newtype="expect"
                    oldinfo["step"]=each.get("title")
                else:
                    oldinfo["expect"]=each.get("title")
            if each.get("topic") or each.get("topics"):
                (each.get("topic") and a([each.get("topic")],oldinfo,newtype))
                (each.get("topics") and a(each.get("topics"),oldinfo,newtype))
            else:
                case_list.append(oldinfo)
    a(content,{},"name")               
    name=list(map(lambda x:x.get("name"),case_list))
    step=list(map(lambda x:x.get("step"),case_list))
    expect=list(map(lambda x:x.get("expect"),case_list))
    dataframe = pd.DataFrame({"用例名":name,"用例步骤":step,"预期结果":expect})
    dataframe.to_csv("test.csv",index=False,sep=',')

# makecase("/home/yaowenhui/galaxTestCenter/1.07.xmind")
# relational_case("STARCOM")

a=1

b= a and 12 or 13
print(b)

    